From: Masami Hiramatsu <mhiramat@kernel.org>
To: Steven Rostedt <rostedt@goodmis.org>, linux-kernel@vger.kernel.org
Cc: mhiramat@kernel.org, Ingo Molnar <mingo@redhat.com>,
Namhyung Kim <namhyung@kernel.org>,
Tom Zanussi <tom.zanussi@linux.intel.com>,
Arnaldo Carvalho de Melo <acme@kernel.org>,
linux-trace-users@vger.kernel.org,
linux-kselftest@vger.kernel.org, shuah@kernel.org,
Ravi Bangoria <ravi.bangoria@linux.vnet.ibm.com>
Subject: [PATCH v7 13/16] selftests: ftrace: Add a testcase for symbol type
Date: Wed, 25 Apr 2018 21:22:24 +0900 [thread overview]
Message-ID: <152465894448.26224.1696382157544475060.stgit@devbox> (raw)
In-Reply-To: <152465856498.26224.16969986455942749517.stgit@devbox>
Add a testcase for symbol type with kprobe event.
This tests good/bad syntax combinations and also
the traced data.
If the kernel doesn't support symbol type, it skips
the test as UNSUPPORTED.
Signed-off-by: Masami Hiramatsu <mhiramat@kernel.org>
---
Changes in v3:
- Use IP/PC register to test the symbol type
---
.../ftrace/test.d/kprobe/kprobe_args_symbol.tc | 77 ++++++++++++++++++++
1 file changed, 77 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_symbol.tc
diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_symbol.tc b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_symbol.tc
new file mode 100644
index 000000000000..20a8664a838b
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_symbol.tc
@@ -0,0 +1,77 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: Kprobe event argument symbol type
+
+[ -f kprobe_events ] || exit_unsupported # this is configurable
+
+grep -qe "type:.* symbol" README || exit_unsupported # version issue
+
+echo 0 > events/enable
+echo > kprobe_events
+
+PROBEFUNC="vfs_read"
+GOODREG=
+BADREG=
+REG=
+GOODSYM="_sdata"
+if ! grep -qw ${GOODSYM} /proc/kallsyms ; then
+ GOODSYM=$PROBEFUNC
+fi
+
+case `uname -m` in
+x86_64|i[3456]86)
+ GOODREG=%ax
+ BADREG=%ex
+ REG=%ip
+;;
+aarch64)
+ GOODREG=%x0
+ BADREG=%ax
+ REG=%pc
+;;
+arm*)
+ GOODREG=%r0
+ BADREG=%ax
+ REG=%pc
+;;
+*)
+ echo "Please implement other architecture here"
+ exit_untested
+esac
+
+test_goodarg() # Good-args
+{
+ while [ "$1" ]; do
+ echo "p ${PROBEFUNC} $1" > kprobe_events
+ shift 1
+ done;
+}
+
+test_badarg() # Bad-args
+{
+ while [ "$1" ]; do
+ ! echo "p ${PROBEFUNC} $1" > kprobe_events
+ shift 1
+ done;
+}
+
+echo > kprobe_events
+
+: "Symbol type"
+test_goodarg "${GOODREG}:symbol" "@${GOODSYM}:symbol" "@${GOODSYM}+10:symbol" \
+ "\$stack0:symbol" "+0(\$stack):symbol"
+test_badarg "\$comm:symbol"
+
+: "Retval with symbol type"
+echo "r ${PROBEFUNC} \$retval:symbol" > kprobe_events
+
+echo > kprobe_events
+
+: "Test get symbol"
+echo "p:testprobe create_trace_kprobe ${REG}:symbol" > kprobe_events
+echo 1 > events/kprobes/testprobe/enable
+! echo test >> kprobe_events
+tail -n 1 trace | grep -q "arg1=create_trace_kprobe"
+
+echo 0 > events/enable
+echo > kprobe_events
next prev parent reply other threads:[~2018-04-25 12:22 UTC|newest]
Thread overview: 36+ messages / expand[flat|nested] mbox.gz Atom feed top
2018-04-25 12:16 [PATCH v7 00/16] tracing: probeevent: Improve fetcharg features Masami Hiramatsu
2018-04-25 12:16 ` [PATCH v7 01/16] tracing: probeevent: Cleanup print argument functions Masami Hiramatsu
2018-04-25 12:17 ` [PATCH v7 02/16] tracing: probeevent: Cleanup argument field definition Masami Hiramatsu
2018-04-25 12:17 ` [PATCH v7 03/16] tracing: probeevent: Remove NOKPROBE_SYMBOL from print functions Masami Hiramatsu
2018-04-25 12:18 ` [PATCH v7 04/16] tracing: probeevent: Introduce new argument fetching code Masami Hiramatsu
2018-04-25 12:18 ` [PATCH v7 05/16] tracing: probeevent: Unify fetch type tables Masami Hiramatsu
2018-04-25 12:19 ` [PATCH v7 06/16] tracing: probeevent: Return consumed bytes of dynamic area Masami Hiramatsu
2018-04-25 12:19 ` [PATCH v7 07/16] tracing: probeevent: Append traceprobe_ for exported function Masami Hiramatsu
2018-04-25 12:19 ` [PATCH v7 08/16] tracing: probeevent: Unify fetch_insn processing common part Masami Hiramatsu
2018-04-25 12:20 ` [PATCH v7 09/16] tracing: probeevent: Add symbol type Masami Hiramatsu
2018-04-25 12:20 ` [PATCH v7 10/16] x86: ptrace: Add function argument access API Masami Hiramatsu
2018-04-25 12:21 ` [PATCH v7 11/16] tracing: probeevent: Add $argN for accessing function args Masami Hiramatsu
2018-04-25 12:21 ` [PATCH v7 12/16] tracing: probeevent: Add array type support Masami Hiramatsu
2018-04-25 12:22 ` Masami Hiramatsu [this message]
2018-04-25 12:22 ` [PATCH v7 14/16] selftests: ftrace: Add a testcase for $argN with kprobe_event Masami Hiramatsu
2018-04-25 12:23 ` [PATCH v7 15/16] selftests: ftrace: Add a testcase for array type " Masami Hiramatsu
2018-04-25 12:23 ` [PATCH v7 16/16] perf-probe: Add array argument support Masami Hiramatsu
2018-04-27 1:42 ` [PATCH v7 00/16] tracing: probeevent: Improve fetcharg features Steven Rostedt
2018-05-03 22:11 ` Steven Rostedt
2018-05-04 15:48 ` Masami Hiramatsu
2018-05-04 16:06 ` Steven Rostedt
2018-05-04 17:30 ` Naveen N. Rao
2018-05-05 2:38 ` Masami Hiramatsu
2018-05-05 7:46 ` Naveen N. Rao
2018-05-05 14:32 ` Masami Hiramatsu
2018-05-07 8:11 ` Naveen N. Rao
2018-05-07 14:53 ` Masami Hiramatsu
2018-05-08 10:11 ` Naveen N. Rao
2018-05-08 15:02 ` Masami Hiramatsu
2018-05-08 18:01 ` Naveen N. Rao
2018-05-05 15:51 ` Masami Hiramatsu
2018-05-07 15:30 ` Steven Rostedt
2018-05-08 4:01 ` Masami Hiramatsu
2018-05-07 15:21 ` Steven Rostedt
2018-06-21 20:16 ` Steven Rostedt
2018-06-22 6:04 ` Masami Hiramatsu
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=152465894448.26224.1696382157544475060.stgit@devbox \
--to=mhiramat@kernel.org \
--cc=acme@kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=linux-kselftest@vger.kernel.org \
--cc=linux-trace-users@vger.kernel.org \
--cc=mingo@redhat.com \
--cc=namhyung@kernel.org \
--cc=ravi.bangoria@linux.vnet.ibm.com \
--cc=rostedt@goodmis.org \
--cc=shuah@kernel.org \
--cc=tom.zanussi@linux.intel.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox